import { css as $, LitElement as D, html as v, svg as I } from "lit";
import { property as S, state as g, customElement as P, query as A } from "lit/decorators.js";
import { a as V, f as H, b as C, c as x, d as k, e as q, h as z, t as F, i as R } from "./functions.7b9d19fa.js";
import { classMap as c } from "lit/directives/class-map.js";
function u(y, e, t, i) {
  var n = arguments.length, s = n < 3 ? e : i === null ? i = Object.getOwnPropertyDescriptor(e, t) : i, r;
  if (typeof Reflect == "object" && typeof Reflect.decorate == "function")
    s = Reflect.decorate(y, e, t, i);
  else
    for (var a = y.length - 1; a >= 0; a--)
      (r = y[a]) && (s = (n < 3 ? r(s) : n > 3 ? r(e, t, s) : r(e, t)) || s);
  return n > 3 && s && Object.defineProperty(e, t, s), s;
}
class L {
  constructor(e, t) {
    this.runtime = e, this.canvas = t, this.disposed = !1, this.analyser = e.audioCtx.createAnalyser(), this.analyser.fftSize = 8192, this.analyser.smoothingTimeConstant = 0.5, e.connect(this.analyser), this.analysisData = new Uint8Array(this.analyser.frequencyBinCount);
    let i = Math.log10(e.audioCtx.sampleRate / 2) - 1;
    this.canvas.width = this.canvas.offsetWidth * window.devicePixelRatio, this.canvas.height = this.canvas.offsetHeight * window.devicePixelRatio, this.analysisXs = this.calculateAnalysisXs(i), this.resizeObserver = new ResizeObserver(() => {
      this.canvas.width = this.canvas.offsetWidth * window.devicePixelRatio, this.canvas.height = this.canvas.offsetHeight * window.devicePixelRatio, this.analysisXs = this.calculateAnalysisXs(i);
    }), this.resizeObserver.observe(this.canvas);
  }
  calculateAnalysisXs(e) {
    return Array.from(this.analysisData).map((t, i) => {
      let n = i / this.analysisData.length * (this.runtime.audioCtx.sampleRate / 2);
      return Math.floor((Math.log10(n) - 1) / e * this.canvas.width);
    });
  }
  analyse() {
    let e = () => {
      this.disposed || (this.analyser.getByteFrequencyData(this.analysisData), this.draw(), requestAnimationFrame(e));
    };
    requestAnimationFrame(e);
  }
  draw() {
    let e = this.canvas.width, t = this.canvas.height, i = this.canvas.height / 255, n = this.canvas.getContext("2d");
    if (!n)
      throw new Error("Could not get a canvas context!");
    n.clearRect(0, 0, e, t);
    let s = new Path2D();
    s.moveTo(0, t);
    for (let r = 0; r < this.analysisData.length; r++) {
      let a = Math.floor(t - this.analysisData[r] * i);
      s.lineTo(this.analysisXs[r], a);
    }
    s.lineTo(e, t), n.fillStyle = "rgba(30, 30, 60, 0.7)", n.fill(s), n.strokeStyle = "rgb(155, 155, 255)", n.stroke(s);
  }
  dispose() {
    this.disposed = !0, this.analyser.disconnect(), this.resizeObserver.disconnect();
  }
}
class M {
  constructor(e, t) {
    this.runtime = e, this.canvas = t, this.canvas.width = this.canvas.offsetWidth * window.devicePixelRatio, this.canvas.height = this.canvas.offsetHeight * window.devicePixelRatio, this.frequencies = this.calculateFrequencies(), this.filterMagResponse = new Float32Array(this.frequencies.length), this.filterPhaseResponse = new Float32Array(this.frequencies.length), this.frequencyResponse = new Float32Array(this.frequencies.length), this.resizeObserver = new ResizeObserver(() => {
      this.canvas.width = this.canvas.offsetWidth * window.devicePixelRatio, this.canvas.height = this.canvas.offsetHeight * window.devicePixelRatio, this.frequencies = this.calculateFrequencies(), this.filterMagResponse = new Float32Array(this.frequencies.length), this.filterPhaseResponse = new Float32Array(this.frequencies.length), this.frequencyResponse = new Float32Array(this.frequencies.length), this.render();
    }), this.resizeObserver.observe(this.canvas);
  }
  dispose() {
    this.resizeObserver.disconnect();
  }
  render() {
    this.frequencyResponse.fill(1);
    for (let e = 0; e < this.runtime.spec.length; e++)
      for (let t = 0; t < V(this.runtime.spec[e].type); t++)
        if (this.runtime.getFrequencyResponse(e, t, this.frequencies, this.filterMagResponse, this.filterPhaseResponse))
          for (let n = 0; n < this.frequencyResponse.length; n++)
            this.frequencyResponse[n] *= this.filterMagResponse[n];
    this.draw();
  }
  draw() {
    let e = this.canvas.getContext("2d"), t = this.canvas.width, i = this.canvas.height;
    if (!e)
      throw new Error("Could not get a canvas context!");
    e.clearRect(0, 0, t, i), e.strokeStyle = "#ffffff", e.lineWidth = 2, e.beginPath();
    let n = 13, s = -n;
    for (let r = 0; r < this.frequencyResponse.length; r++) {
      let a = this.frequencyResponse[r], o = 20 * Math.log10(a), l = i - (o - s) / (n - s) * i;
      r === 0 ? e.moveTo(r, l) : e.lineTo(r, l);
    }
    e.stroke();
  }
  calculateFrequencies() {
    let e = new Float32Array(this.canvas.width), t = this.runtime.audioCtx.sampleRate / 2, i = 1, n = Math.log10(t);
    for (let s = 0; s < this.canvas.width; s++) {
      let r = i + s / this.canvas.width * (n - i), a = Math.pow(10, r);
      e[s] = a;
    }
    return e;
  }
}
const Q = $`
  *,
  *::before,
  *::after {
    box-sizing: border-box;
  }

  :host {
    background-color: #111;
    color: white;
    --font-stack: Corbel, "Lucida Grande", "Lucida Sans Unicode", "Lucida Sans",
      "DejaVu Sans", "Bitstream Vera Sans", "Liberation Sans", Verdana,
      "Verdana Ref", sans-serif;
    --font-size: 9px;
    font-family: var(--font-stack);
    font-size: var(--font-size);
  }
`, T = [
  ["noop", "-"],
  ["lowpass12", "LP12"],
  ["lowpass24", "LP24"],
  ["highpass12", "HP12"],
  ["highpass24", "HP24"],
  ["lowshelf12", "LS12"],
  ["lowshelf24", "LS24"],
  ["highshelf12", "HS12"],
  ["highshelf24", "HS24"],
  ["peaking12", "PK12"],
  ["peaking24", "PK24"],
  ["notch12", "NT12"],
  ["notch24", "NT24"]
];
var w;
let f = (w = class extends D {
  constructor() {
    super(...arguments), this.frequencyInputFocused = !1, this.dragStates = { frequency: null, gain: null, Q: null };
  }
  render() {
    if (!this.runtime || this.index === void 0)
      return;
    let e = this.runtime.spec[this.index];
    return v`
      <th
        class=${c({ filterNumber: !0, bypassed: e.bypass })}
        @click=${() => this.toggleBypass()}
      >
        ${this.index + 1}
      </th>
      <td>
        <select
          class=${c({ filterTypeSelect: !0, bypassed: e.bypass })}
          @change=${(t) => this.setFilterType(t.target.value)}
        >
          ${T.map(([t, i]) => v`<option value=${t} ?selected=${e.type === t}>
                ${i}
              </option>`)}
        </select>
      </td>
      <td>
        <input
          class=${c({
      frequencyInput: !0,
      numberInput: !0,
      bypassed: e.bypass
    })}
          type="number"
          step="0.1"
          lang="en_EN"
          .value=${H(e.frequency, this.frequencyInputFocused)}
          ?disabled=${!C(e.type)}
          @focus=${() => this.frequencyInputFocused = !0}
          @blur=${() => {
      this.frequencyInputFocused = !1, this.setFilterFrequency(x(e.frequency, 10, this.nyquist));
    }}
          @input=${(t) => this.setFilterFrequency(t.target.valueAsNumber)}
          @pointerdown=${(t) => this.startDraggingValue(t, "frequency")}
          @pointerup=${(t) => this.stopDraggingValue(t, "frequency")}
          @pointermove=${(t) => this.dragValue(t, "frequency")}
        />
        <span
          class=${c({
      frequencyUnit: !0,
      disabled: !C(e.type),
      bypassed: e.bypass
    })}
          >${k(e.frequency, this.frequencyInputFocused)}</span
        >
      </td>
      <td>
        <input
          class=${c({
      gainInput: !0,
      numberInput: !0,
      bypassed: e.bypass
    })}
          type="number"
          min="-15"
          max="15"
          step="0.1"
          lang="en_EN"
          .value=${e.gain.toFixed(1)}
          ?disabled=${!q(e.type)}
          @input=${(t) => this.setFilterGain(t.target.valueAsNumber)}
          @pointerdown=${(t) => this.startDraggingValue(t, "gain")}
          @pointerup=${(t) => this.stopDraggingValue(t, "gain")}
          @pointermove=${(t) => this.dragValue(t, "gain")}
        />
        <span
          class=${c({
      gainUnit: !0,
      disabled: !q(e.type),
      bypassed: e.bypass
    })}
          >dB</span
        >
      </td>
      <td>
        <input
          class=${c({
      qInput: !0,
      numberInput: !0,
      bypassed: e.bypass
    })}
          type="number"
          min="0.1"
          max="18"
          step="0.1"
          .value=${e.Q.toFixed(2)}
          ?disabled=${!z(e.type)}
          @input=${(t) => this.setFilterQ(t.target.valueAsNumber)}
          @pointerdown=${(t) => this.startDraggingValue(t, "Q")}
          @pointerup=${(t) => this.stopDraggingValue(t, "Q")}
          @pointermove=${(t) => this.dragValue(t, "Q")}
        />
      </td>
    `;
  }
  get nyquist() {
    var e, t;
    return ((t = (e = this.runtime) == null ? void 0 : e.audioCtx.sampleRate) != null ? t : 48e3) / 2;
  }
  toggleBypass() {
    !this.runtime || this.index === void 0 || this.runtime.toggleBypass(this.index, !this.runtime.spec[this.index].bypass);
  }
  setFilterType(e) {
    !this.runtime || this.index === void 0 || this.runtime.setFilterType(this.index, e);
  }
  setFilterFrequency(e) {
    !this.runtime || this.index === void 0 || isNaN(e) || this.runtime.setFilterFrequency(this.index, e);
  }
  setFilterGain(e) {
    !this.runtime || this.index === void 0 || isNaN(e) || this.runtime.setFilterGain(this.index, e);
  }
  setFilterQ(e) {
    !this.runtime || this.index === void 0 || isNaN(e) || this.runtime.setFilterQ(this.index, e);
  }
  startDraggingValue(e, t) {
    !this.runtime || this.index === void 0 || (e.target.setPointerCapture(e.pointerId), e.preventDefault(), this.dragStates = {
      ...this.dragStates,
      [t]: {
        pointer: e.pointerId,
        startY: e.clientY,
        startValue: this.runtime.spec[this.index][t]
      }
    });
  }
  stopDraggingValue(e, t) {
    var i;
    !this.runtime || this.index === void 0 || ((i = this.dragStates[t]) == null ? void 0 : i.pointer) === e.pointerId && (e.target.releasePointerCapture(e.pointerId), this.dragStates[t].startValue !== this.runtime.spec[this.index][t] && e.target.blur(), this.dragStates = { ...this.dragStates, [t]: null });
  }
  dragValue(e, t) {
    if (!this.runtime || this.index === void 0)
      return;
    let i = this.dragStates[t];
    if (i && i.pointer === e.pointerId) {
      let n = i.startY, r = -(e.clientY - n), a = x(r / 150, -1, 1);
      if (t === "frequency") {
        let o = 10, l = this.runtime.audioCtx.sampleRate / 2, h = F(i.startValue, o, l), d = R(h + a, o, l);
        this.runtime.setFilterFrequency(this.index, d);
      } else if (t === "gain") {
        let o = a * 15;
        this.runtime.setFilterGain(this.index, x(i.startValue + o, -15, 15));
      } else if (t === "Q") {
        let o = 0.1, l = 18, h = F(i.startValue, o, l), d = R(h + a, o, l);
        this.runtime.setFilterQ(this.index, d);
      }
    }
  }
}, (() => {
  w.styles = [
    Q,
    $`
      :host {
        display: table-row;
      }
      input,
      select {
        padding: 0;
        border: 0;
      }
      .filterNumber {
        width: 10px;
        cursor: pointer;
      }
      .filterTypeSelect {
        width: 30px;

        appearance: none;
        outline: none;
        background-color: transparent;
        color: white;
        cursor: pointer;
        text-align: center;
        font-family: var(--font-stack);
        font-size: var(--font-size);
      }
      .frequencyInput {
        width: 20px;
      }
      .gainInput {
        width: 23px;
      }
      .qInput {
        width: 30px;
      }
      .numberInput {
        appearance: none;
        outline: none;
        background-color: transparent;
        color: white;
        text-align: right;
        -moz-appearance: textfield;
        font-family: var(--font-stack);
        font-size: var(--font-size);
        touch-action: none;
      }
      .numberInput:disabled,
      .disabled {
        color: #555;
        pointer-events: none;
      }
      .bypassed {
        color: #555;
      }
      .numberInput::-webkit-inner-spin-button,
      .numberInput::-webkit-outer-spin-button {
        -webkit-appearance: none !important;
        margin: 0 !important;
      }
    `
  ];
})(), w);
u([
  S({ attribute: !1 })
], f.prototype, "runtime", void 0);
u([
  S()
], f.prototype, "index", void 0);
u([
  g()
], f.prototype, "frequencyInputFocused", void 0);
u([
  g()
], f.prototype, "dragStates", void 0);
f = u([
  P("weq8-ui-filter-row")
], f);
var b;
let p = (b = class extends D {
  constructor() {
    super(...arguments), this.gridXs = [], this.dragStates = {};
  }
  updated(e) {
    var t, i;
    if (e.has("runtime") && ((t = this.analyser) == null || t.dispose(), (i = this.frequencyResponse) == null || i.dispose(), this.runtime && this.analyserCanvas && this.frequencyResponseCanvas)) {
      this.analyser = new L(this.runtime, this.analyserCanvas), this.analyser.analyse(), this.frequencyResponse = new M(this.runtime, this.frequencyResponseCanvas), this.frequencyResponse.render();
      let n = [], s = this.runtime.audioCtx.sampleRate / 2, r = Math.floor(Math.log10(s));
      for (let a = 0; a < r; a++) {
        let o = Math.pow(10, a + 1);
        for (let l = 1; l < 10; l++) {
          let h = o * l;
          if (h > s)
            break;
          n.push((Math.log10(h) - 1) / (Math.log10(s) - 1) * 100);
        }
      }
      this.gridXs = n, this.runtime.on("filtersChanged", () => {
        var a, o, l;
        (a = this.frequencyResponse) == null || a.render(), this.requestUpdate();
        for (let h of Array.from((l = (o = this.shadowRoot) == null ? void 0 : o.querySelectorAll("weq8-ui-filter-row")) != null ? l : []))
          h.requestUpdate();
      });
    }
  }
  render() {
    var e;
    return v`
      <table class="filters">
        <thead>
          <tr>
            <th></th>
            <th>Filter</th>
            <th>Freq</th>
            <th>Gain</th>
            <th>Q</th>
          </tr>
        </thead>
        <tbody>
          ${Array.from({ length: 8 }).map((t, i) => v`<weq8-ui-filter-row .runtime=${this.runtime} .index=${i} />`)}
        </tbody>
      </table>
      <div class="visualisation">
        <svg
          viewBox="0 0 100 10"
          preserveAspectRatio="none"
          xmlns="http://www.w3.org/2000/svg"
        >
          ${this.gridXs.map(this.renderGridX)}
          ${[12, 6, 0, -6, -12].map(this.renderGridY)}
        </svg>
        <canvas class="analyser"></canvas>
        <canvas class="frequencyResponse"></canvas>
        ${(e = this.runtime) == null ? void 0 : e.spec.filter((t) => t.type !== "noop").map((t, i) => this.renderFilterHandle(t, i))}
      </div>
    `;
  }
  renderGridX(e) {
    return I`<line
      class="grid-x"
      x1=${e}
      y1="0"
      x2=${e}
      y2="10"
    />`;
  }
  renderGridY(e) {
    let i = (e + 15) / 30 * 10;
    return I`<line
      class="grid-y"
      x1="0"
      y1=${i}
      x2="100"
      y2=${i}
    />`;
  }
  renderFilterHandle(e, t) {
    var o, l, h, d;
    if (!this.runtime)
      return;
    let i = this.runtime.spec[t].type, n = (l = (o = this.analyserCanvas) == null ? void 0 : o.offsetWidth) != null ? l : 0, s = (d = (h = this.analyserCanvas) == null ? void 0 : h.offsetHeight) != null ? d : 0, r = F(e.frequency, 10, this.runtime.audioCtx.sampleRate / 2) * n, a = s - (e.gain + 15) / 30 * s;
    return q(i) || (a = s - F(e.Q, 0.1, 18) * s), v`<div
      class="filter-handle-positioner"
      style="transform: translate(${r}px,${a}px)"
      @pointerdown=${(m) => this.startDraggingFilterHandle(m, t)}
      @pointerup=${(m) => this.stopDraggingFilterHandle(m, t)}
      @pointermove=${(m) => this.dragFilterHandle(m, t)}
    >
      <div class="filter-handle">${t + 1}</div>
    </div>`;
  }
  startDraggingFilterHandle(e, t) {
    e.target.setPointerCapture(e.pointerId), this.dragStates = { ...this.dragStates, [t]: e.pointerId }, e.preventDefault();
  }
  stopDraggingFilterHandle(e, t) {
    this.dragStates[t] === e.pointerId && (e.target.releasePointerCapture(e.pointerId), this.dragStates = { ...this.dragStates, [t]: null });
  }
  dragFilterHandle(e, t) {
    var i, n;
    if (this.runtime && this.dragStates[t] === e.pointerId) {
      let s = this.runtime.spec[t].type, r = (n = (i = this.frequencyResponseCanvas) == null ? void 0 : i.getBoundingClientRect()) != null ? n : {
        left: 0,
        top: 0,
        width: 0,
        height: 0
      }, a = e.clientX - r.left, o = e.clientY - r.top, l = R(a / r.width, 10, this.runtime.audioCtx.sampleRate / 2);
      this.runtime.setFilterFrequency(t, l);
      let h = 1 - o / r.height;
      if (q(s)) {
        let d = x(h * 30 - 15, -15, 15);
        this.runtime.setFilterGain(t, d);
      } else {
        let d = R(h, 0.1, 18);
        this.runtime.setFilterQ(t, d);
      }
    }
  }
}, (() => {
  b.styles = [
    Q,
    $`
      :host {
        display: flex;
        flex-direction: row;
        align-items: stretch;
        min-width: 600px;
        min-height: 200px;
        padding: 5px;
        overflow: hidden;
      }

      .filters {
        width: 170px;
        border-spacing: 0;
        margin-right: 5px;
      }
      .filters thead th {
        padding-bottom: 10px;
      }

      .visualisation {
        flex: 1;
        position: relative;
      }
      canvas,
      svg {
        position: absolute;
        top: 0;
        left: 0;
        width: 100%;
        height: 100%;
      }
      svg {
        overflow: visible;
      }
      .grid-x,
      .grid-y {
        stroke: #333;
        stroke-width: 1;
        vector-effect: non-scaling-stroke;
      }
      .filter-handle-positioner {
        position: absolute;
        top: 0;
        left: 0;
        width: 30px;
        height: 30px;
        touch-action: none;
      }
      .filter-handle {
        position: absolute;
        top: 0;
        left: 0;
        width: 15px;
        height: 15px;
        border-radius: 50%;
        background-color: #fff;
        color: black;
        transform: translate(-50%, -50%);
        display: flex;
        justify-content: center;
        align-items: center;
        user-select: none;
        cursor: grab;
      }
    `
  ];
})(), b);
u([
  S({ attribute: !1 })
], p.prototype, "runtime", void 0);
u([
  g()
], p.prototype, "analyser", void 0);
u([
  g()
], p.prototype, "frequencyResponse", void 0);
u([
  g()
], p.prototype, "gridXs", void 0);
u([
  g()
], p.prototype, "dragStates", void 0);
u([
  A(".analyser")
], p.prototype, "analyserCanvas", void 0);
u([
  A(".frequencyResponse")
], p.prototype, "frequencyResponseCanvas", void 0);
p = u([
  P("weq8-ui")
], p);
export {
  p as WEQ8UIElement
};
